Index: Article.php
===================================================================
RCS file: /cvsroot/wikipedia/phase3/includes/Article.php,v
retrieving revision 1.185
diff -u -r1.185 Article.php
--- Article.php	31 Jul 2004 21:23:14 -0000	1.185
+++ Article.php	1 Aug 2004 10:32:21 -0000
@@ -1617,6 +1617,8 @@
 
 		# Save it!
 		$newcomment = wfMsg( 'revertpage', $s->old_user_text, $from );
+		if ( $rollbackComment = $wgRequest->getText( 'wpReasonRollback' ) )
+		  $newcomment .= " -> ".htmlspecialchars($rollbackComment);
 		$wgOut->setPagetitle( wfMsg( 'actioncomplete' ) );
 		$wgOut->setRobotpolicy( 'noindex,nofollow' );
 		$wgOut->addHTML( '<h2>' . $newcomment . "</h2>\n<hr />\n" );
Index: DifferenceEngine.php
===================================================================
RCS file: /cvsroot/wikipedia/phase3/includes/DifferenceEngine.php,v
retrieving revision 1.25
diff -u -r1.25 DifferenceEngine.php
--- DifferenceEngine.php	18 Jul 2004 08:48:25 -0000	1.25
+++ DifferenceEngine.php	1 Aug 2004 10:32:23 -0000
@@ -27,7 +27,7 @@
 
 		$wgOut->setArticleFlag( false );
 		if ( ! $this->loadText() ) {
-			$wgOut->setPagetitle( wfMsg( "errorpagetitle" ) );
+      			$wgOut->setPagetitle( wfMsg( "errorpagetitle" ) );
 			$wgOut->addHTML( $mtext );
 			wfProfileOut( $fname );
 			return;
@@ -68,18 +68,39 @@
 			"target=" . urlencode($this->mOldUser) );
 		$newContribs = $sk->makeKnownLinkObj( Title::makeTitle( NS_SPECIAL, "Contributions" ), $contribs,
 			"target=" . urlencode($this->mNewUser) );
+
 		if ( !$this->mNewid && $wgUser->isSysop() ) {
-			$rollback = "&nbsp;&nbsp;&nbsp;<strong>[" . $sk->makeKnownLinkObj( $wgTitle, wfMsg( "rollbacklink" ),
-				"action=rollback&from=" . urlencode($this->mNewUser) ) . "]</strong>";
-		} else {
-			$rollback = "";
+			$confirm = htmlspecialchars( wfMsg( 'confirm' ) );
+			$wgOut->addHTML( "
+<strong>".ucFirst( wfMsg( "rollbacklink" ) ).":</strong><br />
+Do you really want to rollback this page?<br />
+<form id='rollback' method='get'>
+        <input type='hidden' name='title' value='".htmlspecialchars($wgTitle->getPrefixedText())."' />
+        <input type='hidden' name='action' value='rollback' />
+        <input type='hidden' name='from' value='".htmlspecialchars($this->mNewUser)."' />
+	<table border='0'>
+		<tr>
+			<td align='rig'>
+				<label for='wpReasonRollback'>Reason for rolbacking:</label>
+			</td>
+			<td align='left'>
+				<input type='text' size='60' name='wpReasonRollback' id='wpReasonRollback' />
+			</td>
+		</tr>
+		<tr>
+			<td>&nbsp;</td>
+			<td>
+				<input type='submit' name='wpConfirmRollback' value=\"{$confirm}\" />
+			</td>
+		</tr>
+	</table>
+</form><br />\n" );
 		}
 
-		$oldHeader = "<strong>{$this->mOldtitle}</strong><br />$oldUserLink ($oldUTLink | $oldContribs)<br />". 
+		$oldHeader = "<strong>{$this->mOldtitle}</strong><br />$oldUserLink ($oldUTLink | $oldContribs)<br />".
 		  $this->mOldComment;
-		$newHeader = "<strong>{$this->mNewtitle}</strong><br />$newUserLink ($newUTLink | $newContribs) $rollback<br />".
-		  $this->mNewComment;
-
+		$newHeader = "<strong>{$this->mNewtitle}</strong><br />$newUserLink ($newUTLink | $newContribs)<br />";
+		
 		DifferenceEngine::showDiff( $this->mOldtext, $this->mNewtext,
 		  $oldHeader, $newHeader );
 		$wgOut->addHTML( "<hr /><h2>{$this->mNewtitle}</h2>\n" );
@@ -98,7 +119,7 @@
 		  htmlspecialchars( $ntext ) ) );
 
 		$wgOut->addHTML( "<table border='0' width='98%'
-cellpadding='0' cellspacing='4px' class='diff'><tr>
+cellpadding='0' cellspacing='4px' class='diff'><tr valign='top'>
 <td colspan='2' width='50%' align='center' class='diff-otitle'>
 {$otitle}</td>
 <td colspan='2' width='50%' align='center' class='diff-ntitle'>
